/*
  Copyright (C) 2004 Paul Mackerras <paulus@samba.org>

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
  02111-1307, USA.

  The GNU General Public License is contained in the file COPYING.
*/
#include "vg_constants.h"

	.globl VG_(helper_undefined_instruction)
VG_(helper_undefined_instruction):
1:	.long	0
	b	1b

	.globl VG_(helper_loadfpu)
VG_(helper_loadfpu):
#if 0
	mflr	11
	bl	VG_(load_fpu_state)
	mtlr	11
	/* zero out the state pointer to say we loaded it */
	lis	4,VGOFF_(fpu_state_ptr)@ha
	lwz	4,VGOFF_(fpu_state_ptr)@l(4)
	li	0,0
	slwi	4,4,2
	stwx	0,4,31
	blr
#endif
	.globl VG_(load_fpu_state)
VG_(load_fpu_state):
	/* Here r3 contains the pointer to the FPU state */
	lfd	0,256(3)
	mtfsf	0xff,0
	lfd	0,0(3)
	lfd	1,8(3)
	lfd	2,16(3)
	lfd	3,24(3)
	lfd	4,32(3)
	lfd	5,40(3)
	lfd	6,48(3)
	lfd	7,56(3)
	lfd	8,64(3)
	lfd	9,72(3)
	lfd	10,80(3)
	lfd	11,88(3)
	lfd	12,96(3)
	lfd	13,104(3)
	lfd	14,112(3)
	lfd	15,120(3)
	lfd	16,128(3)
	lfd	17,136(3)
	lfd	18,144(3)
	lfd	19,152(3)
	lfd	20,160(3)
	lfd	21,168(3)
	lfd	22,176(3)
	lfd	23,184(3)
	lfd	24,192(3)
	lfd	25,200(3)
	lfd	26,208(3)
	lfd	27,216(3)
	lfd	28,224(3)
	lfd	29,232(3)
	lfd	30,240(3)
	lfd	31,248(3)
	blr

	.globl VG_(helper_storefpu)
VG_(helper_storefpu):
	.globl	VG_(save_fpu_state)
VG_(save_fpu_state):
	/* Save the FPU state in the area pointed to by r3 */
	stfd	0,0(3)
	stfd	1,8(3)
	stfd	2,16(3)
	stfd	3,24(3)
	stfd	4,32(3)
	stfd	5,40(3)
	stfd	6,48(3)
	stfd	7,56(3)
	stfd	8,64(3)
	stfd	9,72(3)
	stfd	10,80(3)
	stfd	11,88(3)
	stfd	12,96(3)
	stfd	13,104(3)
	stfd	14,112(3)
	stfd	15,120(3)
	stfd	16,128(3)
	stfd	17,136(3)
	stfd	18,144(3)
	stfd	19,152(3)
	stfd	20,160(3)
	stfd	21,168(3)
	stfd	22,176(3)
	stfd	23,184(3)
	stfd	24,192(3)
	stfd	25,200(3)
	stfd	26,208(3)
	stfd	27,216(3)
	stfd	28,224(3)
	stfd	29,232(3)
	stfd	30,240(3)
	stfd	31,248(3)
	mffs	0
	stfd	0,256(3)
	blr

	.globl VG_(helper_loadvec)
VG_(helper_loadvec):
	mflr	11
	bl	VG_(load_vec_state)
	mtlr	11
	/* zero out the state pointer to say we loaded it */
	lis	4,VGOFF_(vec_state_ptr)@ha
	lwz	4,VGOFF_(vec_state_ptr)@l(4)
	li	0,0
	slwi	4,4,2
	stwx	0,4,31
	blr

	.globl VG_(load_vec_state)
VG_(load_vec_state):
	/* Here r3 contains the pointer to the vector state */
	li	4,512
	lvx	0,4,3
	mtvscr	0
	lvx	0,0,3
	li	4,16
	lvx	1,4,3
	li	4,32
	lvx	2,4,3
	li	4,48
	lvx	3,4,3
	li	4,64
	lvx	4,4,3
	li	4,80
	lvx	5,4,3
	li	4,96
	lvx	6,4,3
	li	4,112
	lvx	7,4,3
	li	4,128
	lvx	8,4,3
	li	4,144
	lvx	9,4,3
	li	4,160
	lvx	10,4,3
	li	4,176
	lvx	11,4,3
	li	4,192
	lvx	12,4,3
	li	4,208
	lvx	13,4,3
	li	4,224
	lvx	14,4,3
	li	4,240
	lvx	15,4,3
	li	4,256
	lvx	16,4,3
	li	4,272
	lvx	17,4,3
	li	4,288
	lvx	18,4,3
	li	4,304
	lvx	19,4,3
	li	4,320
	lvx	20,4,3
	li	4,336
	lvx	21,4,3
	li	4,352
	lvx	22,4,3
	li	4,368
	lvx	23,4,3
	li	4,384
	lvx	24,4,3
	li	4,400
	lvx	25,4,3
	li	4,416
	lvx	26,4,3
	li	4,432
	lvx	27,4,3
	li	4,448
	lvx	28,4,3
	li	4,464
	lvx	29,4,3
	li	4,480
	lvx	30,4,3
	li	4,496
	lvx	31,4,3
	lwz	4,512(3)
	mtvrsave 4
	blr

	.globl	VG_(save_vec_state)
VG_(save_vec_state):
	/* Save the vector state in the area pointed to by r3 */
	stvx	0,0,3
	li	4,16
	stvx	1,4,3
	li	4,32
	stvx	2,4,3
	li	4,48
	stvx	3,4,3
	li	4,64
	stvx	4,4,3
	li	4,80
	stvx	5,4,3
	li	4,96
	stvx	6,4,3
	li	4,112
	stvx	7,4,3
	li	4,128
	stvx	8,4,3
	li	4,144
	stvx	9,4,3
	li	4,160
	stvx	10,4,3
	li	4,176
	stvx	11,4,3
	li	4,192
	stvx	12,4,3
	li	4,208
	stvx	13,4,3
	li	4,224
	stvx	14,4,3
	li	4,240
	stvx	15,4,3
	li	4,256
	stvx	16,4,3
	li	4,272
	stvx	17,4,3
	li	4,288
	stvx	18,4,3
	li	4,304
	stvx	19,4,3
	li	4,320
	stvx	20,4,3
	li	4,336
	stvx	21,4,3
	li	4,352
	stvx	22,4,3
	li	4,368
	stvx	23,4,3
	li	4,384
	stvx	24,4,3
	li	4,400
	stvx	25,4,3
	li	4,416
	stvx	26,4,3
	li	4,432
	stvx	27,4,3
	li	4,448
	stvx	28,4,3
	li	4,464
	stvx	29,4,3
	li	4,480
	stvx	30,4,3
	li	4,496
	stvx	31,4,3
	li	4,512
	mfvscr	0
	stvx	0,4,3
	mfvrsave 4
	stw	4,512(3)
	blr
